const ExceptionHandler = {
    getErrorMessage( error ){
        if( !error ) return "UNEXPECTED_ERROR";
        if( error.message ) return error.message;
        if( error ) return error;
        return "UNEXPECTED_ERROR";
    },
    
    defaultHandler( error ){
        const now = new Date().toLocaleString();
        const errorMsg = this.getErrorMessage( error );
        console.log(`Error ${now} ------`);
        console.log(errorMsg);
    },
    statusHandler( error ){
        let errorMsg = this.getErrorMessage( error );
        if(errorMsg.includes('ORA-')) return 'SQL_ERROR';
        return "UNKNOWN_ERROR";
    }
}

export default ExceptionHandler;