<?php
namespace BackOfficeOptimizer\Providers;

class PermissionProvider{
    protected $connection;

    public function __construct($connection = null){
        $this->connection = $connection ?? ConnectionProvider::create();
    }
    
    public function setConnection($connection) {
        $this->connection = $connection;
    }

    public function getUserPermissions($CDOPERADOR, $NRORG){
        $accessControllStatusSQL = "SELECT CASE WHEN MAX(A.NRPERFILACESSO) IS NULL THEN 'N' ELSE 'S' END AS CONTROLA_ACESSO, CASE WHEN MAX(OP.NRPERFILACESSO) IS NULL THEN 'N' ELSE 'S' END AS ADMINISTRADOR FROM AUTPERFILACESSO A LEFT JOIN (SELECT PF.NRPERFILACESSO, OP.NRORG FROM OPERADOR OP INNER JOIN PERFACESSPARC PF ON (PF.NRPARCNEGOCIO = OP.NRPARCNEGOCIO AND PF.NRORG = OP.NRORG) WHERE OP.CDOPERADOR = :CDOPERADOR AND OP.NRORG = :NRORG ) OP ON A.NRPERFILACESSO = OP.NRPERFILACESSO AND A.NRORG = OP.NRORG WHERE A.IDAUTPERFACESSO = 'OTIMIZADORCARD' AND A.NRORG = :NRORG";

        $statement = $this->connection->prepare($accessControllStatusSQL);

        $statement->execute(["CDOPERADOR" => $CDOPERADOR, "NRORG" => $NRORG]);
        $result = $statement->fetchAll();
        $grantAll = count($result) < 1 || $result[0]["ADMINISTRADOR"] === "S" || $result[0]["CONTROLA_ACESSO"] === "N";
        $scopes = [];
        if(!$grantAll){
            $permissionsSQL = "SELECT DISTINCT OT.NROTIMIZADORITEM FROM OPERADOR OP INNER JOIN PERFACESSPARC PF ON (PF.NRPARCNEGOCIO = OP.NRPARCNEGOCIO AND PF.NRORG = OP.NRORG) INNER JOIN OTIMIZADORITEMPER OT ON (OT.NRORG = PF.NRORG AND OT.NRPERFILACESSO = PF.NRPERFILACESSO) WHERE OP.CDOPERADOR = :CDOPERADOR AND OP.NRORG = :NRORG ORDER BY OT.NROTIMIZADORITEM";
        
            $statement = $this->connection->prepare($permissionsSQL);
            $statement->execute(["CDOPERADOR" => $CDOPERADOR, "NRORG" => $NRORG]);
            $scopesRes = $statement->fetchAll();
            if(sizeof($scopesRes) > 0){
                foreach($scopesRes as $sc) {
                    $scopes[] = $sc["NROTIMIZADORITEM"];
                }
            }
        }

        $permissions = [
            "grantAll" => $grantAll,
            "scopes" => $scopes,
            "canAccessPermissionManagement" => $result[0]["ADMINISTRADOR"] === "S" && $result[0]["CONTROLA_ACESSO"] === "S"
        ];

        return $permissions;
    }
}